package org.wso2.registry.web.actions;

import org.wso2.registry.*;
import org.wso2.registry.web.actions.utils.ResourceData;
import org.wso2.registry.exceptions.RegistryException;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

public class AssociationTreeViewAction extends AbstractRegistryAction {
    private String resourcePath;
    private String associationTree = "";
    private int assoIndex = 0;

    public void execute(HttpServletRequest request) throws RegistryException {
        setRequest(request);

        List fatherAsso = provideChildAssociations(resourcePath);
        Iterator ifatherAssofaterAsso = fatherAsso.iterator();
        while (ifatherAssofaterAsso.hasNext()) {
            Association asso = (Association) ifatherAssofaterAsso.next();
            createAssociationTree(asso.getDestinationPath(), asso.getAssociationType());
        }
    }

    public void createAssociationTree(String path, String type) {
        assoIndex++;
        Registry registry;
        try {
            registry = getRegistry();

            Resource father = registry.get(path);
            String fatherResourceType = father instanceof Collection ? ResourceData.COLLECTION : ResourceData.RESOURCE;
            //infinityLoop.add(new String(path));
            //String infinityLoopItem =
            List fatherAsso = provideChildAssociations(path);

            associationTree += "<div class=\"father-object\" >";
            associationTree += "<ul class=\"tree-row-object\"><li class=\"first\">";
            if (!fatherAsso.isEmpty()) {
                associationTree += "<a onclick=\"showHideCommon('y_"+assoIndex+"');showHideCommon('xminus_" + assoIndex + "');showHideCommon('xplus_" + assoIndex + "');\">" +
                        "<img src=\"/wso2registry/admin/images/icon-tree-minus.jpg\" id=\"xminus_" + assoIndex + "\" style=\"margin-right:2px;\" />" +
                        "<img src=\"/wso2registry/admin/images/icon-tree-plus.jpg\" id=\"xplus_" + assoIndex + "\" style=\"margin-right:2px;display:none;\" />" +
                        "</a>";
            } else {
                associationTree += "<img src=\"/wso2registry/admin/images/spacer.gif\" style=\"width:8px;\" />";
            }

            if (fatherResourceType.equals(ResourceData.COLLECTION)) {
                associationTree += "<img src=\"/wso2registry/admin/images/icon-folder-small.gif\" style=\"margin-right:2px;\" />";
            } else {
                associationTree += "<img src=\"/wso2registry/admin/images/editshred.png\" style=\"margin-right:2px;\" />";
            }

            associationTree += "<a href=\"" + calculateRelativePath(path) + "\">" + path + "</a></li>" +
                    "<li class=\"second\">" + type + "</li>" + "<li class=\"third\">" + type + "</li>" +
                    "</ul></div>";
            if (!fatherAsso.isEmpty()) {
                associationTree += "<div class=\"child-objects\" id=\"y_" + assoIndex + "\">";
                Iterator iAssofaterAsso = fatherAsso.iterator();
                while (iAssofaterAsso.hasNext()) {
                    Association asso = (Association) iAssofaterAsso.next();

                    // if path is equal to the destination path, it is a backward association. we are only displaying
                    // the forward associations here
                    if (!path.equals(asso.getDestinationPath())) {
                        createAssociationTree(asso.getDestinationPath(), asso.getAssociationType());
                    }
                }
                associationTree += "</div>";
            }
        } catch (RegistryException e) {
            e.printStackTrace(); 
        }


    }

    public String calculateRelativePath(String resourcePath) {
        if (resourcePath.startsWith("http://")) {
            return resourcePath;
        }

        String relativePath = resourcePath;

        if (RegistryConstants.ROOT_PATH.equals(resourcePath)) {
            relativePath = "";
        } else {
            if (resourcePath.startsWith(RegistryConstants.PATH_SEPARATOR)) {
                relativePath = resourcePath.substring(1, resourcePath.length());
            }
        }
        return relativePath;
    }

    public List provideChildAssociations(String resourcePath) throws RegistryException {
        List associations = new ArrayList();
        Registry registry = getRegistry();
        Resource resource = registry.get(resourcePath);
        Association[] asso = registry.getAllAssociations(resource.getPath()); 
        associations.addAll(Arrays.asList(asso));

        return associations;
    }


    public String getResourcePath() {
        return resourcePath;
    }

    public void setResourcePath(String resourcePath) {
        this.resourcePath = resourcePath;
    }

    public String getAssociationTree() {
        return associationTree;
    }

    public void setAssociationTree(String associationTree) {
        this.associationTree = associationTree;
    }

}
